// ILVideo.cpp : implementation file
//

#include "stdafx.h"
#include "ILVideo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CILVideo

CILVideo::CILVideo()
{
	m_ImageSize=m_BitmapSize=CSize(0,0);
	hCursorHand=NULL;
	m_nDirection=UP;
	nImageCount=0;
	nTimerID=0;
	m_nFrequency=60;
	m_bPlaying=FALSE;
	m_nRotate=0;
	m_nPosition=0;
	bAdjustWindow2IconSize=FALSE;
	m_bDoByOrder=TRUE;
}

CILVideo::~CILVideo()
{
	if (hCursorHand)
		::DestroyCursor(hCursorHand);
}


BEGIN_MESSAGE_MAP(CILVideo, CWnd)
	//{{AFX_MSG_MAP(CILVideo)
	ON_WM_TIMER()
	ON_WM_SETCURSOR()
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CILVideo message handlers

BOOL CILVideo::Create(UINT nID,CWnd *pParent,RECT &rc)
{
	DWORD dwFlags = WS_CHILDWINDOW|WS_VISIBLE|WS_OVERLAPPED;
	return CWnd::Create(NULL,NULL,dwFlags,rc,pParent,nID,NULL);
}
BOOL CILVideo::CreateFromStatic(UINT nID,CWnd *pParent)
{
	CStatic wndStatic;
	if (!wndStatic.SubclassDlgItem(nID, pParent))
		return FALSE;

	// Get static control rect, convert to parent's client coords.
	CRect rc;
	wndStatic.GetWindowRect(&rc);
	pParent->ScreenToClient(&rc);
	wndStatic.DestroyWindow();
	return Create(nID,pParent,rc);
}

BOOL CILVideo::PreCreateWindow(CREATESTRUCT& cs) 
{
	static LPCTSTR lpszWndClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW);
	cs.lpszClass = lpszWndClass;
	cs.style = WS_CHILDWINDOW|WS_VISIBLE|WS_OVERLAPPED;
	return CWnd::PreCreateWindow(cs);
}

int CILVideo::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}
void CILVideo::OnDestroy() 
{
	Pause();
	CWnd::OnDestroy();
}

void CILVideo::OnTimer(UINT nIDEvent) 
{
	if (nTimerID==nIDEvent) {
		Step();
		return;
	}
	CWnd::OnTimer(nIDEvent);
}

BOOL CILVideo::SetHandCursor(BOOL bSet)
{
	if (!bSet && hCursorHand)
	{
		::DestroyCursor(hCursorHand);
		hCursorHand=NULL;
		return FALSE;
	}
	if (bSet && hCursorHand)  
		return TRUE;

    CString windir;
    ::GetWindowsDirectory(windir.GetBuffer(MAX_PATH), MAX_PATH);
    windir.ReleaseBuffer();
    windir += _T("\\winhlp32.exe");
    HMODULE hModule = LoadLibrary(windir);
	if (hModule){
		hCursorHand = CopyCursor(::LoadCursor(hModule, MAKEINTRESOURCE(106)));
		FreeLibrary(hModule);
		return TRUE;
	}
	return (hCursorHand!=NULL);
}
BOOL CILVideo::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if (hCursorHand)
	{
		::SetCursor(hCursorHand);
		return TRUE;
	}	
	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

void CILVideo::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	rc = CRect(0,0,cx,cy); 
}
void CILVideo::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	if (!m_bitmap.GetSafeHandle())
		return; //no bitmap (nothing to draw)
	int iCurrentImage = GetPosition();

	//checking whether picture is horizontal or vertical
	//in order to find start position of first bitmap
	CSize m_StartPoint;
	BOOL bHorz = (m_BitmapSize.cx > m_BitmapSize.cy);
	m_StartPoint = (bHorz) ?
		CSize( iCurrentImage * m_ImageSize.cx, 0) 
		: CSize(0,iCurrentImage * m_ImageSize.cy); 

	CPalette *pOldPalette = dc.SelectPalette(&m_palette,FALSE);
	dc.RealizePalette();

	CDC memDC;
	memDC.CreateCompatibleDC(&dc);
	CBitmap *pOldBitmap = memDC.SelectObject(&m_bitmap);

	// all instantiated once (quicker)
	static int nPrevMM;
	static CSize szPrevWinExt;
	static CSize szPrevVPExt;

	if (!bAdjustWindow2IconSize) { // do stretch
		nPrevMM = dc.SetMapMode(MM_ANISOTROPIC);
		szPrevWinExt = dc.SetWindowExt(m_ImageSize);
		szPrevVPExt = dc.SetViewportExt(rc.Width(),rc.Height());
	}
	// for all (BitBlt that does StretchBlt)
	::BitBlt(dc.GetSafeHdc(),0,0,m_ImageSize.cx,m_ImageSize.cy, 
				memDC.GetSafeHdc(),m_StartPoint.cx,m_StartPoint.cy,SRCCOPY);
	if (!bAdjustWindow2IconSize) { // do stretch
		dc.SetViewportExt(szPrevVPExt);
		dc.SetWindowExt(szPrevWinExt);
		dc.SetMapMode(nPrevMM);
	}

	memDC.SelectObject(pOldBitmap);
	dc.SelectPalette( pOldPalette, FALSE);
}


/*
void CILVideo::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	if (!m_bitmap.GetSafeHandle())
		return; //no bitmap (nothing to draw)
	int iCurrentImage = GetPosition();

	//checking whether picture is horizontal or vertical
	//in order to find start position of first bitmap
	CSize m_StartPoint;
	BOOL bHorz = (m_BitmapSize.cx > m_BitmapSize.cy);
	m_StartPoint = (bHorz) ?
		CSize( iCurrentImage * m_ImageSize.cx, 0) 
		: CSize(0,iCurrentImage * m_ImageSize.cy); 

	CPalette *pOldPalette = dc.SelectPalette(&m_palette,FALSE);
	dc.RealizePalette();

	CDC memDC;
	memDC.CreateCompatibleDC(&dc);
	CBitmap *pOldBitmap = memDC.SelectObject(&m_bitmap);

	if (bAdjustWindow2IconSize)
		::BitBlt(dc.GetSafeHdc(),0,0,m_ImageSize.cx,m_ImageSize.cy, 
					memDC.GetSafeHdc(),m_StartPoint.cx,m_StartPoint.cy,SRCCOPY);
	else {
		CRect rc;
		GetClientRect(&rc);
		::StretchBlt(dc.GetSafeHdc(),0,0,rc.right,rc.bottom,
			memDC.GetSafeHdc(),m_StartPoint.cx,m_StartPoint.cy,
			m_ImageSize.cx,m_ImageSize.cy,SRCCOPY);
	}

	memDC.SelectObject(pOldBitmap);
	dc.SelectPalette( pOldPalette, FALSE);
}
*/

////////////////////////////////////////////////////////////////
// Load Bitmap function
BOOL CILVideo::LoadBitmap(LPCTSTR lpszResourceName,int cx,int cy,BOOL bAdjust)
{
	bAdjustWindow2IconSize = bAdjust;
	m_ImageSize = CSize(cx,cy);
	AdjustSize(cx,cy);
	
	HBITMAP hbm = (HBITMAP)::LoadImage( 
		AfxGetInstanceHandle(),
		lpszResourceName,	IMAGE_BITMAP,
		0, 0, LR_CREATEDIBSECTION);

	if (!hbm)	return FALSE;
	if (!m_bitmap.Attach(hbm)) {
		::DeleteObject(hbm);
		return FALSE;
	}

	BITMAP bm;
	m_bitmap.GetObject(sizeof(BITMAP),&bm);
	m_BitmapSize = CSize(bm.bmWidth,bm.bmHeight);
	
	CClientDC dc(NULL);
	if (dc.GetDeviceCaps(RASTERCAPS) & RC_PALETTE == 0)
		return TRUE;

	if (m_bitmap.GetSafeHandle()) {
		int nColors;
		DIBSECTION  ds;
		m_bitmap.GetObject(sizeof(DIBSECTION),&ds);

		if (ds.dsBmih.biClrUsed != 0)
			nColors = ds.dsBmih.biClrUsed;
		else nColors = 1 << ds.dsBmih.biBitCount;

		if (nColors > 256)
			m_palette.CreateHalftonePalette(&dc);
		else { //nColors < 256)
			RGBQUAD  *pRGB = new RGBQUAD[nColors];
			if (!pRGB)  return FALSE;

			CDC memDC;
			memDC.CreateCompatibleDC(&dc);
			CBitmap *pOldBitmap = memDC.SelectObject(&m_bitmap);
			::GetDIBColorTable( memDC.GetSafeHdc(), 0, nColors, pRGB);
			memDC.SelectObject(pOldBitmap);

			UINT nSize = sizeof(LOGPALETTE) + 
				(sizeof(PALETTEENTRY) * (nColors+1));
			LOGPALETTE *pLP = (LOGPALETTE*) new BYTE[nSize];
			pLP->palVersion = 0x300;
			pLP->palNumEntries = nColors;

			for (int i=0 ; i<nColors ; i++) {
				pLP->palPalEntry[i].peBlue = pRGB[i].rgbRed;
				pLP->palPalEntry[i].peGreen = pRGB[i].rgbGreen;
				pLP->palPalEntry[i].peBlue = pRGB[i].rgbBlue;
				pLP->palPalEntry[i].peFlags = 0;
			}
			m_palette.CreatePalette(pLP);
			delete [] pLP;
			delete [] pRGB;
		} // (nColors < 256)
	} // got bitmap

	//Find the count of images
	nImageCount = (m_ImageSize.cx==m_BitmapSize.cx) ? (m_BitmapSize.cy/m_ImageSize.cy)
			: (m_BitmapSize.cx/m_ImageSize.cx);

	return TRUE;
}

void CILVideo::AdjustSize(int cx,int cy)
{
	ASSERT(cx>0); //measurements must be valid
	ASSERT(cy>0);
	if (!bAdjustWindow2IconSize)  return;
	
	CRect rect;
	GetWindowRect(&rect);
	CPoint point(rect.TopLeft()); //ressetting the control
	//according the top-left spot (we may resset according
	//another spot too : top-right is useful(for right alignment))
	::ScreenToClient(::GetParent(m_hWnd),&point);
	MoveWindow(point.x,point.y,cx,cy);
}

/////////////////////////////////////////////////////////////////////////////
// CILVideo members
BOOL CILVideo::Play()
{
	if (nTimerID)  return TRUE; //already got timer
	nTimerID = SetTimer(1000, m_nFrequency,NULL);
	m_bPlaying = TRUE;
	return (nTimerID!=0);
}
BOOL CILVideo::Pause() 
{
	if (nTimerID!=0 && KillTimer(nTimerID)) {
		nTimerID=0;
		m_bPlaying = FALSE;
	}
	return (nTimerID==0);
}
int CILVideo::SetFrequency(int nFrequency) 
{
	if (nFrequency<=20 && nFrequency>40000)
		return m_nFrequency; // invalid value
	m_nFrequency = nFrequency;
	if (m_bPlaying) { //reset of play (with new frequency)
		Pause();
		Play();
	}
	return m_nFrequency;
}
int CILVideo::SetDirection(int nDirection)
{
	if (nDirection==UP || nDirection==DOWN)
		m_nDirection = nDirection;
	return GetDirection();
}

// This function moves to the next place and draws the next image
// (plays 1 step in animation)

BOOL CILVideo::Step()
{
	int iCurrentPosition = GetPosition();
	int iCurrentDirection = GetDirection();

	iCurrentPosition = (m_nDirection==UP) ? iCurrentPosition+1 : 
			iCurrentPosition-1;
	if (m_bDoByOrder) {
		iCurrentPosition++;
		if (iCurrentPosition>=nImageCount)
			iCurrentPosition=0;
	}
	else {
		if (iCurrentPosition>=nImageCount && m_nDirection==UP) {
			iCurrentPosition = nImageCount-1;
			m_nDirection=DOWN;
		}
		else if (iCurrentPosition<0 && m_nDirection==DOWN) {
			iCurrentPosition = 0;
			m_nDirection=UP;
		}
	}
	if (iCurrentPosition>=0 && iCurrentPosition<nImageCount)
		m_nPosition=iCurrentPosition;

	Invalidate();
	UpdateWindow();
	return TRUE;
}


/*
BOOL CILVideo::Step(BOOL bMoveNext)
{
	int iCurrentPosition = GetPosition();
	int iCurrentDirection = GetDirection();

	if (m_bDoByOrder) {
		iCurrentPosition++;
		if (iCurrentPosition>=nImageCount)
			iCurrentPosition=0;
	}
	else {

		iCurrentPosition = (m_nDirection==UP) ? iCurrentPosition+1 :
			iCurrentPosition-1;
		
		if (iCurrentPosition>=nImageCount && m_nDirection==UP) {
			iCurrentPosition--;// = nImageCount-1;
			m_nDirection=DOWN;
		}
		else if (iCurrentPosition<0 && m_nDirection==DOWN) {
			iCurrentPosition++;// = 0;
			m_nDirection=UP;
		}
	}
	// sets position
	if (iCurrentPosition>=0 && iCurrentPosition<nImageCount)
		m_nPosition=iCurrentPosition;


	Invalidate();
	UpdateWindow();
	return TRUE;
}
*/

void CILVideo::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CWnd::OnLButtonUp(nFlags, point);
	if (hCursorHand && strLink.GetLength())
	{
		::ShellExecute(m_hWnd,_T("open"),strLink,NULL,NULL,SW_SHOWDEFAULT);
		Invalidate();
		UpdateWindow();
	}
}
