#if !defined(AFX_ILVIDEO_H__2BE15CC7_EEE8_11D4_B808_EE484B1E4D14__INCLUDED_)
#define AFX_ILVIDEO_H__2BE15CC7_EEE8_11D4_B808_EE484B1E4D14__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ILVideo.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CILVideo window

class CILVideo : public CWnd
{
public:
	CILVideo();
	virtual ~CILVideo();

	BOOL Create(UINT nID,CWnd *pParent,RECT &rc);
	BOOL CreateFromStatic(UINT nID,CWnd *pParent);

	BOOL LoadBitmap(LPCTSTR lpszResourceName,int cx,int cy,BOOL bAdjust=TRUE);
	BOOL LoadBitmap(UINT nID,int cx,int cy,BOOL bAdjust=TRUE) {
		return LoadBitmap(MAKEINTRESOURCE(nID),cx,cy,bAdjust);
	}
	BOOL SetHandCursor(BOOL bSet);

	CString GetLink() { return strLink; }
	void SetLink(LPCTSTR lpszLink=NULL) {
		if (lpszLink) strLink=lpszLink;
	}

	BOOL Play();
	BOOL Pause();
	int SetFrequency(int nFrequency=60);
	void SetPlayMode(BOOL bDoByOrder) { m_bDoByOrder=bDoByOrder; } 
	BOOL GetPlayMode() { return m_bDoByOrder; } 

	//{{AFX_VIRTUAL(CILVideo)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

public:

protected:
	//{{AFX_MSG(CILVideo)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	UINT nTimerID;
	int  m_nFrequency;
	BOOL m_bPlaying;
	int m_nRotate;// rotation of every image in drawing
	CRect rc;	

	BOOL Step();
	int GetPosition()  const {	return m_nPosition; }
	int m_nPosition;

	void AdjustSize(int cx,int cy);

	enum { UP = 1, DOWN = 2 };
	int GetDirection() { return m_nDirection; }
	int SetDirection(int nDirection=UP);
	int m_nDirection; //1=up 2=down

	int nImageCount;
	CSize m_ImageSize, // size of each image 
			m_BitmapSize; // size of whole image 

	CBitmap m_bitmap;
	CPalette  m_palette;

	HIMAGELIST hImage;
	HCURSOR	hCursorHand;
	CString strLink;
	BOOL bAdjustWindow2IconSize;
	BOOL m_bDoByOrder;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ILVIDEO_H__2BE15CC7_EEE8_11D4_B808_EE484B1E4D14__INCLUDED_)
